import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';

import { TranslateLoader } from '@ngx-translate/core';
import { ElectronProxyService } from './electron-proxy.service';

@Injectable({
  providedIn: 'root'
})
export class I18nService extends TranslateLoader {
  private prefix: string;
  private suffix: string;

  public constructor(
    private electronProxyService: ElectronProxyService,
  ) {
    super();

    this.prefix = 'assets/i18n';
    this.suffix = 'json';
  }

  getTranslation(lang: string): Observable<any> {
    return this.electronProxyService.getRendererI18n({
      filePath: __DEV__ ? `src/${this.prefix}` : `${this.prefix}`,
      fileName: `${lang}.${this.suffix}`,
    });
  }

}
