import {
  Actions,
  ActionType,
} from './infra.action';

import {
  State,
  initialState,
} from './infra.state';

export function reducer(state: State = initialState, action: Actions): State {
  switch (action.type) {
    case ActionType.SetHosts: {
      return {
        ...state,
        hosts: action.payload,
      };
    }

    case ActionType.SetPorts: {
      return {
        ...state,
        ports: action.payload,
      };
    }

    case ActionType.SetServices: {
      return {
        ...state,
        services: action.payload,
      };
    }

    case ActionType.ChangeInfraDisplayType: {
      return {
        ...state,
        infraDisplayType: action.payload.infraDisplayType,
      };
    }

    case ActionType.RefreshInfraDisplay: {
      return {
        ...state,
        refreshInfraDisplay: action.payload,
      };
    }

    case ActionType.ChangeSelectedInfra: {
      return {
        ...state,
        selectedInfra: action.payload,
      };
    }

    case ActionType.ChangeInfraDisplayElementRef: {
      return {
        ...state,
        infraDisplayElementRef: action.payload.infraDisplayElementRef,
      };
    }

    default: {
      return state;
    }
  }
}
